// Generated by LiveScript 1.4.0
/**
 * @package    CleverStyle CMS
 * @subpackage System module
 * @category   modules
 * @author     Nazar Mokrynskyi <nazar@mokrynskyi.com>
 * @copyright  Copyright (c) 2015-2016, Nazar Mokrynskyi
 * @license    MIT License, see license.txt
 */
(function(){
  var L;
  L = cs.Language;
  Polymer({
    'is': 'cs-system-admin-permissions-for',
    behaviors: [cs.Polymer.behaviors.Language('system_admin_permissions_')],
    properties: {
      'for': {
        type: String,
        value: ''
      },
      group: '',
      user: '',
      all_permissions: Array,
      permissions: Object
    },
    ready: function(){
      var this$ = this;
      Promise.all([$.getJSON('api/System/admin/blocks'), $.getJSON('api/System/admin/permissions'), $.getJSON("api/System/admin/" + this['for'] + "s/" + this[this['for']] + "/permissions")]).then(function(arg$){
        var blocks, all_permissions, permissions, block_index_to_title, res$, group, labels, label, id;
        blocks = arg$[0], all_permissions = arg$[1], permissions = arg$[2];
        block_index_to_title = {};
        blocks.forEach(function(block){
          return block_index_to_title[block.index] = block.title;
        });
        res$ = [];
        for (group in all_permissions) {
          labels = all_permissions[group];
          res$.push({
            group: group,
            labels: (fn$())
          });
        }
        this$.all_permissions = res$;
        this$.permissions = permissions;
        function fn$(){
          var ref$, results$ = [];
          for (label in ref$ = labels) {
            id = ref$[label];
            results$.push({
              name: label,
              id: id,
              description: group === 'Block' ? block_index_to_title[label] : ''
            });
          }
          return results$;
        }
      });
    },
    save: function(){
      $.ajax({
        url: "api/System/admin/" + this['for'] + "s/" + this[this['for']] + "/permissions",
        data: $(this.$.form).serialize(),
        type: 'put',
        success: function(){
          cs.ui.notify(L.changes_saved, 'success', 5);
        }
      });
    },
    invert: function(e){
      $(e.currentTarget).closest('div').find(':radio:not(:checked)[value!=-1]').parent().click();
    },
    allow_all: function(e){
      $(e.currentTarget).closest('div').find(':radio[value=1]').parent().click();
    },
    deny_all: function(e){
      $(e.currentTarget).closest('div').find(':radio[value=0]').parent().click();
    },
    permission_state: function(id, expected){
      var permission;
      permission = this.permissions[id];
      return permission == expected || (expected == '-1' && permission === undefined);
    }
  });
}).call(this);
